Attribute VB_Name = "Module1"
Option Explicit

Public Width As Integer
Public Height As Integer
Public X As Integer
Public Y As Integer
Public Visible As Boolean
Public ZOrder  As Single
Public Alpha      As Single
Public TopTexWin As cTexture

'{------------------------------------------------------------------}
'{  Initialise window and setup defaults                            }
'{------------------------------------------------------------------}
Public Sub TWindow(wX As Integer, wY As Integer, wWidth As Integer, wHeight As Integer)

      X = wX
      Y = wY
      ZOrder = 0        '// used if you specifically want to set a window higher
      Width = wWidth
      Height = wHeight
      Visible = True    '// start off visible
      Alpha = 0.9       '// defult for alpha blending
End Sub

'{------------------------------------------------------------------}
'{  Render the window. Calls render button, child windows ...       }
'{------------------------------------------------------------------}
Public Function Render() As Boolean
  
      If Visible Then
            Call glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
            Call glEnable(GL_DEPTH_TEST)
            Call glEnable(GL_BLEND)
            Call glColor4f(1#, 1#, 1#, Alpha)

            Call glPushMatrix
            Call glTranslatef(X, Form1.ScaleHeight, ZOrder)
            Call glBegin(GL_QUADS)
            '// top left corner of window.
            Call glTexCoord2f(0 / 128, 1):             Call glVertex2f(0, 0)
            Call glTexCoord2f(0 / 128, 1 - 11 / 128):  Call glVertex2f(0, -11)
            Call glTexCoord2f(64 / 128, 1 - 11 / 128): Call glVertex2f(63, -11)
            Call glTexCoord2f(64 / 128, 1):            Call glVertex2f(63, 0)

            '// top of window.
            Call glTexCoord2f(64 / 128, 1):            Call glVertex2f(63, 0)
            Call glTexCoord2f(64 / 128, 1 - 11 / 128): Call glVertex2f(63, -11)
            Call glTexCoord2f(96 / 128, 1 - 11 / 128): Call glVertex2f(Width - 32, -11)
            Call glTexCoord2f(96 / 128, 1):            Call glVertex2f(Width - 32, 0)

            '// top right corder of window.
            Call glTexCoord2f(96 / 128, 1):            Call glVertex2f(Width - 32, 0)
            Call glTexCoord2f(96 / 128, 1 - 11 / 128): Call glVertex2f(Width - 32, -11)
            Call glTexCoord2f(1, 1 - 11 / 128):        Call glVertex2f(Width, -11)
            Call glTexCoord2f(1, 1):                   Call glVertex2f(Width, 0)

            '// left side of window.
            Call glTexCoord2f(0 / 128, 1 - 11 / 128): Call glVertex2f(0, -11)
            Call glTexCoord2f(0 / 128, 11 / 128):     Call glVertex2f(0, -Height + 11)
            Call glTexCoord2f(6 / 128, 11 / 128):     Call glVertex2f(6, -Height + 11)
            Call glTexCoord2f(6 / 128, 1 - 11 / 128): Call glVertex2f(6, -11)

            '// right side of window.
            Call glTexCoord2f(1 - 7 / 128, 1 - 11 / 128): Call glVertex2f(Width - 7, -11)
            Call glTexCoord2f(1 - 7 / 128, 11 / 128):     Call glVertex2f(Width - 7, -Height + 11)
            Call glTexCoord2f(1, 11 / 128):               Call glVertex2f(Width, -Height + 11)
            Call glTexCoord2f(1, 1 - 11 / 128):           Call glVertex2f(Width, -11)

            '// bottom left corner of window.
            Call glTexCoord2f(0 / 128, 11 / 128):         Call glVertex2f(0, 11 - Height)
            Call glTexCoord2f(0 / 128, 0 / 128):          Call glVertex2f(0, -Height)
            Call glTexCoord2f(64 / 128, 0 / 128):         Call glVertex2f(63, -Height)
            Call glTexCoord2f(64 / 128, 11 / 128):        Call glVertex2f(63, 11 - Height)

            '// bottom of window.
            Call glTexCoord2f(64 / 128, 11 / 128):        Call glVertex2f(63, 11 - Height)
            Call glTexCoord2f(64 / 128, 0 / 128):         Call glVertex2f(63, -Height)
            Call glTexCoord2f(96 / 128, 0 / 128):         Call glVertex2f(Width - 32, -Height)
            Call glTexCoord2f(96 / 128, 11 / 128):        Call glVertex2f(Width - 32, 11 - Height)

            '// bottom right corder of window.
            Call glTexCoord2f(96 / 128, 11 / 128):        Call glVertex2f(Width - 32, 11 - Height)
            Call glTexCoord2f(96 / 128, 0 / 128):         Call glVertex2f(Width - 32, -Height)
            Call glTexCoord2f(1, 0 / 128):                Call glVertex2f(Width, -Height)
            Call glTexCoord2f(1, 11 / 128):               Call glVertex2f(Width, 11 - Height)
            Call glEnd
    
            Call glPopMatrix
            Call glBlendFunc(GL_ONE, GL_ONE)
            Call glDisable(GL_BLEND)
      End If
      Render = True
End Function

'{------------------------------------------------------------------}
'{  Procedure to create all the windows and their buttton           }
'{------------------------------------------------------------------}
Public Function InitGUI() As Boolean
      Set TopTexWin = New cTexture
      TopTexWin.loadTexture App.Path + "\Gui.bmp", FILETYPE_BMP

      Call TWindow(0, 0, 223, 154)               '// create the window
      InitGUI = True
End Function

'{------------------------------------------------------------------}
'{  Procedure to render the GUI                                     }
'{------------------------------------------------------------------}
Public Function RenderGUI()
      TopTexWin.useTexture
      Call glMatrixMode(GL_PROJECTION)         '// Change Matrix Mode to Projection
      Call glLoadIdentity                      '// Reset View
      Call glOrtho(0, Form1.ScaleWidth, 0, Form1.ScaleHeight, 0, 100)
      Call glMatrixMode(GL_MODELVIEW)          '// Change Projection to Matrix Mode
      Call glLoadIdentity

      Call glTranslatef(0, 0, -1)
      Call glEnable(GL_TEXTURE_2D)
      Call Render                              '// draw the main window and it will draw child windows
      
      Call glMatrixMode(GL_PROJECTION)         '// Change Matrix Mode to Projection
      Call glLoadIdentity                      '// Reset View
      Call gluPerspective(45#, Form1.ScaleWidth / Form1.ScaleHeight, 1#, 100#)
      Call glMatrixMode(GL_MODELVIEW)          '// Change Projection to Matrix Mode
      Call glLoadIdentity
End Function

