Attribute VB_Name = "mGlobal"
Option Explicit

' Win32 Structures
Private Type RECT
      Left As Long
      Top As Long
      Right As Long
      Bottom As Long
End Type

Public Type RGBQUAD
      rgbBlue As Byte
      rgbGreen As Byte
      rgbRed As Byte
      rgbReserved As Byte
End Type
Private Const CCDEVICENAME = 32
Private Const CCFORMNAME = 32

' DEVMODE declare used to query Windows for the
' Display device settings
' the one in the typelib has problems so I included this one.
Public Type DEVMODE
      dmDeviceName        As String * CCDEVICENAME
      dmSpecVersion       As Integer
      dmDriverVersion     As Integer
      dmSize              As Integer
      dmDriverExtra       As Integer
      dmFields            As Long
      dmOrientation       As Integer
      dmPaperSize         As Integer
      dmPaperLength       As Integer
      dmPaperWidth        As Integer
      dmScale             As Integer
      dmCopies            As Integer
      dmDefaultSource     As Integer
      dmPrintQuality      As Integer
      dmColor             As Integer
      dmDuplex            As Integer
      dmYResolution       As Integer
      dmTTOption          As Integer
      dmCollate           As Integer
      dmFormName          As String * CCFORMNAME
      dmUnusedPadding     As Integer
      dmBitsPerPel        As Integer
      dmPelsWidth         As Long
      dmPelsHeight        As Long
      dmDisplayFlags      As Long
      dmDisplayFrequency  As Long
End Type

'API declarations
Public Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Public Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwflags As Long) As Long
Public Declare Function CreateIC Lib "gdi32" Alias "CreateICA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long

Public hrc As Long
Public fullscreen As Boolean
Public OldWidth As Long
Public OldHeight As Long
Public OldBits As Long
Public OldVertRefresh As Long

Public mPointerCount As Integer

Public fWidth As Long
Public fHeight As Long

Public Const FONT_HEIGHT = 14
'Private Constants ------------------------------------------------------------
Public Const NUM_TEXTURES As Integer = 1

'Global Variables -------------------------------------------------------------
Public gaTextures() As Long
'Local Variables --------------------------------------------------------------
Public base As GLuint
Public FontText As GLuint
Public bDone As Boolean
Public NewmnuIndex As Integer
Public NewWindow As Boolean
Public Keys(255) As Boolean             ' used to keep track of key_downs
Public EnableBeat As Boolean
Public ElapsedTime As Long
Public BounceBeat As Boolean
Public HelpScreen As Boolean
Public LastTime As Long
Public PluginStart As Long
Public ToplamBass  As GLfloat
Public SpData(1 To 288) As GLfloat
Public Spdata1(1 To 288) As GLfloat
Public Ortalama    As GLfloat
Public Flash As Boolean
Public ShowSong As Boolean
Public Title     As String
Public ShowVolMsg As Boolean
Public VolMsg    As String
Public Bassvurdu As Boolean
Public ilk_bass As Boolean
Public Original_X_Position As GLfloat
Public Original_Y_Position As GLfloat
Public Current_X As GLfloat
Public BrokenTexture As GLuint
Public PeakFalloff As GLfloat
Public LineFalloff As GLfloat
Public Playing As Boolean
Public mnuIndex As Integer
Public NewTexture As String
Public Line1(1 To 288) As GLfloat
Public Line2(1 To 288) As GLfloat
Public Peak1(1 To 288) As GLfloat
Public Peak2(1 To 288) As GLfloat
Public spectrumDataL
Public spectrumDataR
Public pPolygone As Boolean
Public lRet As Integer

Sub Main()
      Dim Done As Boolean
      Dim frm As Form
      
      Call LoadIni
      Done = False ' we're not done yet
      ' Ask The User Which Screen Mode They Prefer
      'fullscreen = MsgBox("Would You Like To Run In Fullscreen Mode?", vbYesNo + vbQuestion, "Start FullScreen?") = vbYes
    
      ' Create Our OpenGL Window
      Set frm = New Form1     ' create our form
      If Not CreateGLWindow(frm, 231, 154, 32, fullscreen) Then
            Done = True                             ' Quit If Window Was Not Created
      End If
      Call vbmp3_init
      'EnableBeat = True
      Do While Not Done
            ' Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
            If (Keys(vbKeyEscape)) Then  ' Updating View Only If Active
                  Unload frm                          ' ESC or DrawGLScene Signalled A Quit
            Else                                    ' Not Time To Quit, Update Screen
                  LastTime = ElapsedTime
                  ElapsedTime = GetTickCount() - PluginStart         '// Calculate Elapsed Time
                  ElapsedTime = (LastTime + ElapsedTime) \ 2         '// Average it out for smoother movement
                  
                  Call glDraw
                  
                  DoEvents
                  SwapBuffers (frm.hDC)               ' Swap Buffers (Double Buffering)
                  DoEvents
            End If

            If Keys(vbKeyF1) Then                   ' Is F1 Being Pressed?
                  Keys(vbKeyF1) = False               ' If So Make Key FALSE
                  Unload frm                          ' Kill Our Current Window
                  Set frm = New Form1                 ' create a new one
                  fullscreen = Not fullscreen         ' Toggle Fullscreen / Windowed Mode
                  If mnuIndex = 2 Then DrawPeristalsis = True
                  ' Recreate Our OpenGL Window
                  If Not CreateGLWindow(frm, 1152, 864, 32, fullscreen) Then
                        Unload frm                      ' Quit If Window Was Not Created
                  End If
            End If
            Done = frm.Visible = False              ' if the form is not visible then we are done
      Loop
      ' Shutdown
      Set frm = Nothing ' destroy our form
      Call vbmp3_stop
      End
End Sub
'Converts a string into a Byte Array
Public Function StringToByteArray(str As String) As Variant

      Dim bray() As Byte
      Dim cnt As Integer
      Dim ln As Integer
      ln = Len(str)
      ReDim bray(ln)

      For cnt = 0 To ln - 1

            bray(cnt) = Asc(Mid$(str, cnt + 1, 1))
      Next cnt
      bray(ln) = 0
      StringToByteArray = bray

End Function

'//------------------------------------------------------------------}
'//  Position the Text from curent Screen - widht and Height         }
'//------------------------------------------------------------------}
Public Sub PositionText(X As Integer, Y As Integer)

      Call glPushAttrib(GL_TRANSFORM_BIT Or GL_VIEWPORT_BIT)
      '// Here we use a new projection and modelview matrix to work with.
      Call glMatrixMode(GL_PROJECTION)                        '// Set our matrix to our projection matrix
      Call glPushMatrix                                       '// Push on a new matrix to work with
      Call glLoadIdentity                                     '// reset the matrix
      Call glMatrixMode(GL_MODELVIEW)                         '// Set our matrix to our model view matrix
      Call glPushMatrix                                       '// Push on a new matrix to work with
      Call glLoadIdentity                                     '// Reset that matrix
      Y = Form1.ScaleHeight - FONT_HEIGHT - Y               '// Calculate the weird screen position
      Call glViewport(X - 1, Y - 1, 0, 0)                     '// Create a new viewport to draw into
      Call glRasterPos4f(0, 0, 0, 1)                          '// Set the drawing position
      Call glPopMatrix                                        '// Pop the current modelview matrix off the stack
      Call glMatrixMode(GL_PROJECTION)                        '// Go back into projection mode
      Call glPopMatrix                                        '// Pop the projection matrix off the stack
      Call glPopAttrib                                        '// This restores our TRANSFORM and VIEWPORT attributes

End Sub

Public Sub glPrintBitmap(X, Y As GLfloat, s As String, fontset As GLint) '// Where The Printing Happens

      If (fontset > 1) Then fontset = 1

      Dim b() As Byte
      Dim i As Integer

      If Len(s) > 0 Then                                                 '// only if the pass a string

            ReDim b(Len(s))                                              '// array of bytes to hold the string

            For i = 1 To Len(s)                                          '// for each character

                  b(i) = Asc(Mid$(s, i, 1))                              '// convert from unicode to ascii
            Next
            b(Len(s)) = 0                                                '// null terminated
            Call glBindTexture(GL_TEXTURE_2D, FontText)                  '// Select Our Font Texture
            Call glDisable(GL_DEPTH_TEST)                                '// Disables Depth Testing
            Call glMatrixMode(GL_PROJECTION)                             '// Select The Projection Matrix
            Call glPushMatrix                                            '// Store The Projection Matrix
            Call glLoadIdentity                                          '// Reset The Projection Matrix
            Call glOrtho(0, fWidth, 0, fHeight, -100, 100)               '// Set Up An Ortho Screen
            Call glMatrixMode(GL_MODELVIEW)                              '// Select The Modelview Matrix
            Call glPushMatrix                                            '// Store The Modelview Matrix
            Call glLoadIdentity                                          '// Reset The Modelview Matrix
            Call glTranslated(X, Y, 0)                                   '// Position The Text (0,0 - Bottom Left)
            Call glListBase(base - 32 + (128 * fontset))                 '// Choose The Font Set (0 or 1)
            Call glCallLists(Len(s), GL_BYTE, b(0))                      '// Write The Text To The Screen
            Call glMatrixMode(GL_PROJECTION)                             '// Select The Projection Matrix
            Call glPopMatrix                                             '// Restore The Old Projection Matrix
            Call glMatrixMode(GL_MODELVIEW)                              '// Select The Modelview Matrix
            Call glPopMatrix                                             '// Restore The Old Projection Matrix
            Call glEnable(GL_DEPTH_TEST)                                 '// Enables Depth Testing
      End If

End Sub

Public Sub glPrint(X As Integer, Y As Integer, s As String)                          '// Custom GL "Print" Routine

      '// we are just going to provide a simple print routine just like normal basic
      Dim b() As Byte
      Dim i As Integer
      Dim length As Double

      If Len(s) > 0 Then                                     '// only if the pass a string

            ReDim b(Len(s))                                  '// array of bytes to hold the string

            For i = 1 To Len(s)                              '// for each character

                  b(i - 1) = Asc(Mid$(s, i, 1))                  '// convert from unicode to ascii
            Next
            b(Len(s)) = 0                                    '// null terminated
            Call PositionText(X, Y)                          '// Call our own function to position the text on screen
            glTranslatef -length / 2, 0#, 0#
            glPushAttrib GL_LIST_BIT                         '// Pushes The Display List Bits     ( NEW )
            glListBase (base - 32)                           '// Sets The Base Character to 32    ( NEW )
            glCallLists Len(s), GL_UNSIGNED_BYTE, b(0)       '// Draws The Display List Text  ( NEW )
            glPopAttrib                                      '// Pops The Display List Bits   ( NEW )
      End If

End Sub

Public Sub BuildFont()                                       '// Build Our Bitmap Font

      Dim hfont As Long
      base = glGenLists(96)
      hfont = CreateFont(-9, _
         0, _
         0, _
         0, _
         FW_BOLD, _
         0, _
         0, _
         0, _
         TURKISH_CHARSET, _
         OUT_TT_PRECIS, _
         CLIP_DEFAULT_PRECIS, _
         ANTIALIASED_QUALITY, _
         FF_DONTCARE Or DEFAULT_PITCH, _
         "Arial") _
      
         Call SelectObject(Form1.hDC, hfont)                       '// Selects The Font We Want
      Call wglUseFontBitmaps(Form1.hDC, 32, 96, base)              '// Builds 96 Characters Starting At Character 32

End Sub

Public Sub killFont()                                                '// Delete The Font

      Call glDeleteLists(base, 96)                                   '// Delete All 96 Characters

End Sub

Public Sub glWrite(X, Y As GLuint, text As String)

      Dim drawRect As RECT
      Call glPushAttrib(GL_DEPTH_TEST)  '// Save the current Depth test settings (Used for blending )
      Call glDisable(GL_DEPTH_TEST)     '// Turn off depth testing (otherwise we get no FPS)
      Call glDisable(GL_TEXTURE_2D)     '// Turn off textures, don't want our text textured
      Call glMatrixMode(GL_PROJECTION)  '// Switch to the projection matrix
      Call glPushMatrix                 '// Save current projection matrix
      Call glLoadIdentity
      Call GetWindowRect(GetDesktopWindow(), drawRect)  '// Get current window size
      Call glOrtho(0, drawRect.Right, 0, drawRect.Bottom, -1, 1)  '// Change the projection matrix using an orthgraphic projection
      Call glMatrixMode(GL_MODELVIEW)   '// Return to the modelview matrix
      Call glPushMatrix                 '// Save the current modelview matrix
      Call glLoadIdentity
      Call glColor3f(1#, 1#, 1#)        '// Text color
      Call glRasterPos2f(X, Y)                                '// Position the Text
      Call glPushAttrib(GL_LIST_BIT)                          '// Save's the current base list
      Call glListBase(base - 32)                              '// Set the base list to our character list
      Call glCallLists(Len(text), GL_UNSIGNED_BYTE, CStr(text)) '// Display the text
      Call glPopAttrib                                        '// Restore the old base list
      Call glMatrixMode(GL_PROJECTION)  '//Switch to projection matrix
      Call glPopMatrix                  '// Restore the old projection matrix
      Call glMatrixMode(GL_MODELVIEW)   '// Return to modelview matrix
      Call glPopMatrix                  '// Restore old modelview matrix
      Call glEnable(GL_TEXTURE_2D)      '// Turn on textures, don't want our text textured
      Call glPopAttrib                  '// Restore depth testing

End Sub

Public Sub BuildBitmapFont()                                     '// Build Our Font Display List

      Dim cx As Single
      Dim cy As Single
      Dim X As Integer
      base = glGenLists(256)                                     '// Creating 256 Display Lists
      Call glBindTexture(GL_TEXTURE_2D, FontText)                '// Select Our Font Texture

      For X = 0 To 255                                           '// Loop Through All 256 Lists

            cx = (X \ 16) / 16                                   '// X Position Of Current Character
            cy = (X \ 16) / 16                                   '// Y Position Of Current Character
            Call glNewList(base + X, GL_COMPILE)                 '// Start Building A List
            Call glBegin(GL_QUADS)                               '// Use A Quad For Each Character
            Call glTexCoord2f(cx, 1 - cy - 0.0625)               '// Texture Coord (Bottom Left)
            Call glVertex2i(0, 0)                                '// Vertex Coord (Bottom Left)
            Call glTexCoord2f(cx + 0.0625, 1 - cy - 0.0625)      '// Texture Coord (Bottom Right)
            Call glVertex2i(16, 0)                               '// Vertex Coord (Bottom Right)
            Call glTexCoord2f(cx + 0.0625, 1 - cy)               '// Texture Coord (Top Right)
            Call glVertex2i(16, 16)                              '// Vertex Coord (Top Right)
            Call glTexCoord2f(cx, 1 - cy)                        '// Texture Coord (Top Left)
            Call glVertex2i(0, 16)                               '// Vertex Coord (Top Left)
            Call glEnd                                           '// Done Building Our Quad (Character)
            Call glTranslated(10, 0, 0)                          '// Move To The Right Of The Character
            Call glEndList                                       '// Done Building The Display List
      Next X                                                     '// Loop Until All 256 Are Built

End Sub

Public Sub SaveCurrentScreen()

      ' Save the current screen resolution, bits, and Vertical refresh
      Dim Ret As Long
      Ret = CreateIC("DISPLAY", "", "", 0&)                 '// create display information context
      OldWidth = GetDeviceCaps(Ret, HORZRES)                '// get the current width
      OldHeight = GetDeviceCaps(Ret, VERTRES)               '// and current height
      OldBits = GetDeviceCaps(Ret, BITSPIXEL)               '// and bits per pixel (color depth)
      OldVertRefresh = GetDeviceCaps(Ret, VREFRESH)         '// and current refresh rate (this may cause problems in Win98
      Ret = DeleteDC(Ret)                                   '// delete the information context

End Sub

Public Function FindDEVMODE(ByVal Width As Integer, ByVal Height As Integer, ByVal Bits As Integer, Optional ByVal VertRefresh As Long = -1) As DEVMODE

      '// locate a DEVMOVE that matches the passed parameters
      Dim Ret As Boolean
      Dim i As Long
      Dim dm As DEVMODE
      i = 0

      Do  '// enumerate the display settings until we find the one we want

            Ret = EnumDisplaySettings(0&, i, dm) ' get windows to enumerate the display settings

            If dm.dmPelsWidth = Width And _
               dm.dmPelsHeight = Height And _
               dm.dmBitsPerPel = Bits And _
               ((dm.dmDisplayFrequency = VertRefresh) Or (VertRefresh = -1)) Then Exit Do ' exit when we have a match

            i = i + 1
      Loop Until (Ret = False)
      FindDEVMODE = dm

End Function

Public Sub ResetDisplayMode()

      Dim dm As DEVMODE
      dm = FindDEVMODE(OldWidth, OldHeight, OldBits, OldVertRefresh)  '// find our old display mode
      dm.dmFields = DM_BITSPERPEL Or DM_PELSWIDTH Or DM_PELSHEIGHT    '// what we are about to change

      If OldVertRefresh <> -1 Then

            dm.dmFields = dm.dmFields Or DM_DISPLAYFREQUENCY          '// include vertical refresh
      End If
      '// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.

      If (ChangeDisplaySettings(dm, CDS_FULLSCREEN) <> DISP_CHANGE_SUCCESSFUL) Then

            '// If The Mode Fails, Offer Two Options.  Quit Or Run In A Window.
            MsgBox "The Requested Mode Is Not Supported By Your Video Card", , "NeHe GL"
      End If

End Sub

Public Sub SetDisplayMode(ByVal Width As Integer, ByVal Height As Integer, ByVal Bits As Integer, ByRef fullscreen As Boolean, Optional VertRefresh As Long = -1)

      Dim dmScreenSettings As DEVMODE
      SaveCurrentScreen                           '// save the current screen attributes so we can go back later
      dmScreenSettings = FindDEVMODE(Width, Height, Bits, VertRefresh) ' find a device mode that matches
      dmScreenSettings.dmBitsPerPel = Bits        '// set pixel bits
      dmScreenSettings.dmPelsWidth = Width        '// width
      dmScreenSettings.dmPelsHeight = Height      '// height
      dmScreenSettings.dmFields = DM_BITSPERPEL Or DM_PELSWIDTH Or DM_PELSHEIGHT ' what we are going to change

      If VertRefresh <> -1 Then

            dmScreenSettings.dmDisplayFrequency = VertRefresh '// include vertical refresh
            dmScreenSettings.dmFields = dmScreenSettings.dmFields Or DM_DISPLAYFREQUENCY
      End If
      '// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.

      If (ChangeDisplaySettings(dmScreenSettings, CDS_FULLSCREEN) <> DISP_CHANGE_SUCCESSFUL) Then

            '// If The Mode Fails, Offer Two Options.  Quit Or Run In A Window.

            If (MsgBox("The Requested Mode Is Not Supported By" & vbCr & "Your Video Card. Use Windowed Mode Instead?", vbYesNo + vbExclamation, "NeHe GL") = vbYes) Then

                  fullscreen = False                  '// Select Windowed Mode (Fullscreen=FALSE)
            Else
                  '// Pop Up A Message Box Letting User Know The Program Is Closing.
                  MsgBox "Program Will Now Close.", vbCritical, "ERROR"
                   bDone = False                       '// Exit And Return FALSE
                  Set Form1 = Nothing
            End If
      End If

End Sub

Public Sub KillGLWindow()                                '// Properly Kill The Window

      If fullscreen Then                                 '// Are We In Fullscreen Mode?

            ResetDisplayMode                             '// Switch Back To The Desktop
            ShowPointer                                  '// Show The Mouse Pointer
      End If

      If hrc Then                                        '// Do We Have A Rendering Context?

            If wglMakeCurrent(0, 0) = 0 Then             '// Are We Able To Release The DC And RC Contexts?

                  MsgBox "Release Of DC And RC Failed.", vbInformation, "SHUTDOWN ERROR"
            End If

            If wglDeleteContext(hrc) = 0 Then             '// Are We Able To Delete The RC?

                  MsgBox "Release Rendering Context Failed.", vbInformation, "SHUTDOWN ERROR"
            End If
            hrc = 0                                       '// Set RC To NULL
      End If
      ' Note
      ' The form owns the device context (hDC) window handle (hWnd) and class (main)
      ' so we do not have to do all the extra work

End Sub

Public Sub HidePointer()

      ' hide the cursor (mouse pointer)
      mPointerCount = ShowCursor(False) + 1       '// how many times will we need to hide the pointer

      Do While ShowCursor(False) >= -1            '// make sure it's hidden

      Loop

      Do While ShowCursor(True) <= -1             '// make sure the next call will show it

      Loop
      ShowCursor False                            '// one last time

End Sub

Public Sub ShowPointer()

      ' show the cursor (mouse pointer)

      Do While ShowCursor(False) >= mPointerCount '// restore the cursor back to normal

      Loop

      Do While ShowCursor(True) <= mPointerCount

      Loop

End Sub

Public Sub ReSizeGLScene(ByVal Width As GLsizei, ByVal Height As GLsizei)

      ' Resize And Initialize The GL Window

      If Height = 0 Then                     '// Prevent A Divide By Zero By

            Height = 1                         '// Making Height Equal One
      End If
      glViewport 0, 0, Width, Height         '// Reset The Current Viewport
      glMatrixMode GL_PROJECTION             '// Select The Projection Matrix
      glLoadIdentity                         '// Reset The Projection Matrix
      ' Calculate The Aspect Ratio Of The Window
      gluPerspective 45#, Width / Height, 0.1, 100#
      glMatrixMode GL_MODELVIEW              '// Select The Modelview Matrix
      glLoadIdentity                         '// Reset The Modelview Matrix
      fWidth = Width
      fHeight = Height

End Sub

Public Function ShowbDone(Index As Integer)

      Dim frm As Form
      Set frm = Form1

      If Index <> NewmnuIndex Then

            'Unload frm
            NewWindow = True
      End If
      NewmnuIndex = Index

End Function

Public Function CreateGLWindow(frm As Form, Width As Integer, Height As Integer, Bits As Integer, fullscreenflag As Boolean) As Boolean
      Dim PixelFormat As GLuint                       ' Holds The Results After Searching For A Match
      Dim pfd As PIXELFORMATDESCRIPTOR                ' pfd Tells Windows How We Want Things To Be


      fullscreen = fullscreenflag                     ' Set The Global Fullscreen Flag


      If (fullscreen) Then                            ' Attempt Fullscreen Mode?
            SetDisplayMode Width, Height, Bits, fullscreen
      End If
    
      If fullscreen Then
            HidePointer                                 ' Hide Mouse Pointer
            frm.WindowState = vbMaximized           ' make the form big
      End If

      pfd.cColorBits = Bits               ' color depth
      pfd.cDepthBits = 16
      pfd.dwflags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
      pfd.iLayerType = PFD_MAIN_PLANE
      pfd.iPixelType = PFD_TYPE_RGBA
      pfd.nSize = Len(pfd)
      pfd.nVersion = 1
    
      PixelFormat = ChoosePixelFormat(frm.hDC, pfd)
      If PixelFormat = 0 Then                     ' Did Windows Find A Matching Pixel Format?
            KillGLWindow                            ' Reset The Display
            MsgBox "Can't Find A Suitable PixelFormat.", vbExclamation, "ERROR"
            CreateGLWindow = False                  ' Return FALSE
      End If

      If SetPixelFormat(frm.hDC, PixelFormat, pfd) = 0 Then ' Are We Able To Set The Pixel Format?
            KillGLWindow                            ' Reset The Display
            MsgBox "Can't Set The PixelFormat.", vbExclamation, "ERROR"
            CreateGLWindow = False                           ' Return FALSE
      End If
    
      hrc = wglCreateContext(frm.hDC)
      If (hrc = 0) Then                           ' Are We Able To Get A Rendering Context?
            KillGLWindow                            ' Reset The Display
            MsgBox "Can't Create A GL Rendering Context.", vbExclamation, "ERROR"
            CreateGLWindow = False                  ' Return FALSE
      End If

      If wglMakeCurrent(frm.hDC, hrc) = 0 Then    ' Try To Activate The Rendering Context
            KillGLWindow                            ' Reset The Display
            MsgBox "Can't Activate The GL Rendering Context.", vbExclamation, "ERROR"
            CreateGLWindow = False                  ' Return FALSE
      End If
      frm.Show                                    ' Show The Window
      SetForegroundWindow frm.hWnd                ' Slightly Higher Priority
      'frm.ScaleMode = 3                           '// ScaleMode = Pixel
      frm.SetFocus                                ' Sets Keyboard Focus To The Window
      ReSizeGLScene frm.ScaleWidth, frm.ScaleHeight ' Set Up Our Perspective GL Screen

      If Not InitGL() Then                        ' Initialize Our Newly Created GL Window
            KillGLWindow                            ' Reset The Display
            MsgBox "Initialization Failed.", vbExclamation, "ERROR"
            CreateGLWindow = False                   ' Return FALSE
      End If

      CreateGLWindow = True                       ' Success

End Function

Public Function InitGL() As Boolean
      Call glClearColor(0#, 0#, 0#, 0#)                        '// Black Background
      Call glShadeModel(GL_SMOOTH)                             '// Enables Smooth Color Shading
      Call glClearDepth(1#)                                    '// Depth Buffer Setup
      Call glEnable(GL_DEPTH_TEST)                             '// Enable Depth Buffer
      Call glDepthFunc(GL_LESS)                                '// The Type Of Depth Test To Do

      Call glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)   '//Realy Nice perspective calculations

      Call glEnable(GL_TEXTURE_2D)                             '// Enable Texture Mapping

      Bassvurdu = False
      ilk_bass = False
      PeakFalloff = 0.04
      LineFalloff = 0.1
      InitGL = True                                         ' Initialization Went OK
      InitGUI
End Function


Public Function glDraw()
      
      Select Case mnuIndex
      Case 0
            RenderVu
      Case 1
            ' Here's Where We Do All The Drawing
            glClear clrColorBufferBit Or clrDepthBufferBit  ' Clear The Screen And The Depth Buffer
            glLoadIdentity                                  ' Reset The Current Modelview Matrix
      
            Call glTranslatef(0, 0, -4)
            Call glRotatef(ElapsedTime / 40, 1, 1, 1)
            
            drawBackgroundEffect
      Case 2
            Dim i As Integer
            If DrawPeristalsis = True Then
            Set TubeTex = New cTexture
            Set BackTex = New cTexture
            Set GradientTex = New cTexture
            EnableBeat = True
            Call glClearColor(0#, 0#, 0#, 0#)            '// Black Background
            Call glShadeModel(GL_SMOOTH)                 '// Enables Smooth Color Shading
            Call glClearDepth(1#)                        '// Depth Buffer Setup
            Call glEnable(GL_DEPTH_TEST)                 '// Enable Depth Buffer
            Call glDepthFunc(GL_LESS)                    '// The Type Of Depth Test To Do
            Call glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)   '//Realy Nice perspective calculations
            Call glEnable(GL_TEXTURE_2D)                             '// Enable Texture Mapping

            If NewTexture > " " Then

                TubeTex.loadTexture NewTexture, FILETYPE_BMP
                TubeTex.useTexture
            Else
                TubeTex.loadTexture App.Path + "\Data\" + "images\tube.bmp", FILETYPE_BMP
                TubeTex.useTexture
            End If
                BackTex.loadTexture App.Path + "\Data\" + "images\background.bmp", FILETYPE_BMP
                BackTex.useTexture
                GradientTex.loadTexture App.Path + "\Data\" + "images\gradient.bmp", FILETYPE_BMP
                GradientTex.useTexture

                For i = 0 To MAX_SEGMENTS

                    twist(i) = 0
                    Radius(i) = 1
                Next i
                    DrawPeristalsis = False
                    DemoStart = GetTickCount
                    EnableBeat = True
                    Call CreateTunnel
            Else
                    Call glDrawPeristalsis

                    If HelpScreen Then Call PerDisHelpScreen

                    If pPolygone = True Then

                        Call glPolygonMode(GL_FRONT, GL_LINE)
                        'Call glPolygonMode(GL_BACK, GL_LINE)
                        TopTexWin.useTexture

                    Else
                       Call glPolygonMode(GL_FRONT, GL_FILL)
                       Call glPolygonMode(GL_BACK, GL_FILL)
                    End If
                    End If
      End Select
                    RenderGUI
End Function

