Attribute VB_Name = "mPeristalsis"
Option Explicit
Public Const MAX_SEGMENTS = 64
Public LastTime As Long
Public DemoStart As Long
'// Textures
Public TubeTex As cTexture
Public BackTex As cTexture
Public GradientTex As cTexture
'// User vaiables
Public twist(0 To MAX_SEGMENTS) As GLfloat
Public Radius(0 To MAX_SEGMENTS) As GLfloat
Public Const pi = 3.14159265358979
Public DrawPeristalsis As Boolean
Public Type glCoord
      X As GLfloat
      Y As GLfloat
      z As GLfloat
End Type
Public Type Record
      U As GLfloat
      V As GLfloat
End Type
Dim Tunnels(0 To 32, 0 To 32) As glCoord

'{------------------------------------------------------------------}
'{  Function to draw the actual scene                               }
'{------------------------------------------------------------------}
Public Sub glDrawPeristalsis()

      Dim i As Integer
      Dim j As Integer
      Dim c As GLfloat
      Dim Angle As GLfloat
      Dim WaveTunnel
      Dim TexCoord(32, 32) As Record
      On Error Resume Next
      WaveTunnel = (buffer3(i) + buffer4(i))
      Angle = ElapsedTime / 64
      Call glClear(GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)    '// Clear The Screen And The Depth Buffer
      Call glLoadIdentity                                         '// Reset The View
      Call glPopMatrix
      TubeTex.useTexture
      '// setup texture coordinates

      For i = 0 To 32

            For j = 0 To 32

                  TexCoord(i, j).U = i / 32 + Cos((Angle + 8 * j) / 60) / 2 '//cos((zrot + 8*J)/60)/2
                  TexCoord(i, j).V = j / 32 + (Angle + j) / 120             '//cos((zrot + 8*J)/60)/4
            Next j
      Next i

      If ShowVolMsg = True Then

            Call glEnable(GL_TEXTURE_2D)
            Call glEnable(GL_BLEND)
            Call glPrint(0, 125, VolMsg & " ")
            Call glDisable(GL_BLEND)
      End If
      '// draw tunnel "cylinder"

      For j = 0 To 32

            'If j > 29 Then
            '      c = 1# - (j - 29) / 10
            'Else
            'c = 1#

            If EnableBeat Then

                  Call glColor3f((c + buffer3(i)), c + WaveTunnel, (c + buffer4(i)))
            End If
            Call glBegin(GL_QUADS)

            For i = 0 To 31

                  Call glTexCoord2f(TexCoord(i, j).U, TexCoord(i, j).V): Call glVertex3f(Tunnels(i, j).X, Tunnels(i, j).Y, Tunnels(i, j).z)
                  Call glTexCoord2f(TexCoord(i + 1, j).U, TexCoord(i + 1, j).V): Call glVertex3f(Tunnels(i + 1, j).X, Tunnels(i + 1, j).Y, Tunnels(i + 1, j).z)
                  Call glTexCoord2f(TexCoord(i + 1, j + 1).U, TexCoord(i + 1, j + 1).V): Call glVertex3f(Tunnels(i + 1, j + 1).X, Tunnels(i + 1, j + 1).Y, Tunnels(i + 1, j + 1).z)
                  Call glTexCoord2f(TexCoord(i, j + 1).U, TexCoord(i, j + 1).V): Call glVertex3f(Tunnels(i, j + 1).X, Tunnels(i, j + 1).Y, Tunnels(i, j + 1).z)
            Next i
            Call glEnd
            'End If
      Next j
      DrawSpec

End Sub

Public Sub CreateTunnel()

      Dim i
      Dim j As Integer

      For i = 0 To 32

            For j = 0 To 32

                  Tunnels(i, j).X = (3 - j / 12) * Cos(2 * pi / 32 * i)
                  Tunnels(i, j).Y = (3 - j / 12) * Sin(2 * pi / 32 * i)
                  Tunnels(i, j).z = -j
            Next j
      Next i

End Sub

'//** HELP SCREEN
Public Sub PerDisHelpScreen()

      Call glEnable(GL_BLEND)
      Call glColor3f(1, 1, 1)                                       ' // White Font Color
      Call glPrint(4, 75, ("HILFE - TASTATUR - BEFEHLE "))
      Call glPrint(4, 85, ("------------------------- "))
      Call glPrint(4, 95, ("RAUF      : LAUTSTAERKE + "))
      Call glPrint(4, 105, ("RUNTER  : LAUTSTAERKE - "))
      Call glPrint(4, 115, ("LINKS     : VORHERIGES LIED "))
      Call glPrint(4, 125, ("RECHTS  : NAECHSTES LIED "))
      Call glPrint(4, 135, ("F5           : HINTERGRUND AUFLEUCHTEN "))
      Call glDisable(GL_BLEND)

End Sub

Public Sub DrawSpec()

      'Var
      Dim TotalDataL(1 To 255) As Long
      Dim TotalDataR(1 To 255) As Long
      Dim A        As Integer
      Dim X
      Dim x1       As GLfloat
      Call glLoadIdentity                                          '// Reset The View
      Call glTranslatef(-1.5, -1.45, -4)
      On Error Resume Next
      '// Translate spectrumData array values to OpenGL metrics

      For A = 1 To 255 'Step Wavetable

            TotalDataL(A) = (spectrumDataL(A) \ 32)
            TotalDataR(A) = (spectrumDataR(A) \ 32)
      Next A

      For A = 1 To 255

            SpData(A) = TotalDataL(A) / 32              '// Left
            Spdata1(A) = TotalDataR(A) / 32             '// Right

            If SpData(A) > 1.5 Then SpData(A) = 1.5

            If Spdata1(A) > 1.5 Then Spdata1(A) = 1.5

      Next A

      For A = 1 To 255

            If Peak1(A) < SpData(A) Then Peak1(A) = SpData(A) Else Peak1(A) = Peak1(A) - PeakFalloff

            If Peak2(A) < Spdata1(A) Then Peak2(A) = Spdata1(A) Else Peak2(A) = Peak2(A) - PeakFalloff

            If Line1(A) < SpData(A) Then Line1(A) = SpData(A) Else Line1(A) = Line1(A) - LineFalloff

            If Line2(A) < Spdata1(A) Then Line2(A) = Spdata1(A) Else Line2(A) = Line2(A) - LineFalloff

      Next A
      '// Draw Left and Right Analyzers , blue and red
      Call glEnable(GL_BLEND)
      Call glBlendFunc(GL_ONE, GL_ONE)
      GradientTex.useTexture
      X = -0.8
      x1 = 1.5

      For A = 248 To 10 Step -1

            '// Left analyzer
            Call glBegin(GL_LINES)
            X = X + 0.01
            Call glColor3f(1#, 1#, 1#)
            Call glVertex2f(X, 0#): Call glColor3f(1#, 1#, 1#)

            If Line1(A) < 0 Then Call glVertex2f(X, 0.01) Else Call glVertex2f(X, Line1(A))

            Call glEnd
            '// Left Peaks
            Call glBegin(GL_LINES)
            Call glColor3f(0#, 0#, 1#)

            If Peak1(A) > 0.031 Then Call glVertex2f(X, Peak1(A) - 0.01)

            Call glColor3f(3, 3, 1)
            Call glVertex2f(X, Peak1(A))
            Call glEnd
      Next A

      For A = 10 To 248

            '// Right analyzer
            Call glBegin(GL_LINES)
            x1 = x1 + 0.01
            Call glColor3f(0, 0#, 0.5)
            Call glVertex2f(x1, 0#): Call glColor3f(1, 1, 1#)

            If Line2(A) < 0 Then Call glVertex2f(x1, 0.01) Else Call glVertex2f(x1, Line2(A))

            Call glEnd
            '// Right Peaks
            Call glBegin(GL_LINES)
            Call glColor3f(1, 0, 0)

            If Peak2(A) > 0.031 Then Call glVertex2f(x1, Peak2(A) - 0.03)

            Call glColor3f(3, 3, 1)
            Call glVertex2f(x1, Peak2(A))
      Next A
      Call glEnd
End Sub

