Attribute VB_Name = "mVuBox"
Option Explicit
Private Const pi = 3.14159265358979
Private Const P180 = pi / 180
Public VUBars(16, 16) As GLfloat

'//------------------------------------------------------------------}
'//  Draws a VU bar. Bars go to a lighter blue to the right and      }
'//  fade to black as we go backwards                                }
'//------------------------------------------------------------------}
Public Function VUBox(X, Y, z, Value As GLfloat)

      Dim c
      Dim f As GLfloat
      Dim R
      Dim G
      Dim b As GLfloat
      c = (11.75 + X) / 55 '### amount of color to fade by as we go to the right
      f = (11.5 - z) / 60  '### amount of fade to black as we go back
      R = c - f          '### RED
      G = c - f          '### GREEN
      b = 1 - f          '### BLUE
      '### front
      Call glColor3f(R, G, b)
      Call glVertex3f(X, Y, z)
      Call glVertex3f(X + 0.9, Y, z)
      Call glColor3f(Value / 10 + R, G, b - Value / 10) '### VUBars = values 0 - 10
      Call glVertex3f(X + 0.9, Y + Value, z)
      Call glVertex3f(X, Y + Value, z)
      '### left
      Call glColor3f(R, G, b)
      Call glVertex3f(X, Y, z - 0.9)
      Call glVertex3f(X, Y, z)
      Call glColor3f(Value / 10 + R, G, b - Value / 10)
      Call glVertex3f(X, Y + Value, z)
      Call glVertex3f(X, Y + Value, z - 0.9)
      '### back
      Call glColor3f(R, G, b)
      Call glVertex3f(X + 0.9, Y, z - 0.9)
      Call glVertex3f(X, Y, z - 0.9)
      Call glColor3f(Value / 10 + R, G, b - Value / 10)
      Call glVertex3f(X, Y + Value, z - 0.9)
      Call glVertex3f(X + 0.9, Y + Value, z - 0.9)
      '### right
      Call glColor3f(R, G, b)
      Call glVertex3f(X + 0.9, Y, z)
      Call glVertex3f(X + 0.9, Y, z - 0.9)
      Call glColor3f(Value / 10 + R, G, b - Value / 10)
      Call glVertex3f(X + 0.9, Y + Value, z - 0.9)
      Call glVertex3f(X + 0.9, Y + Value, z)
      '### top
      Call glColor3f(R, G, b)
      Call glVertex3f(X, Y, z)
      Call glVertex3f(X + 0.9, Y, z)
      Call glColor3f(Value / 10 + R, G, b - Value / 10)
      Call glVertex3f(X + 0.9, Y + Value, z - 0.9)
      Call glVertex3f(X, Y + Value, z - 0.9)

End Function

'//--------------------------------------------------------------------}
'//  Main message loop for the application                             }
'//--------------------------------------------------------------------}
Public Function RenderVu() As Boolean

      Dim A As Integer
      
      Call glDisable(GL_TEXTURE_2D)
      '// BackGround Beat Color
      '// Calculates the first 20 values of SpectrumData array
      '// and finds average of it. "Ortalama" is average.
      ToplamBass = 0

      For A = 1 To 20

            ToplamBass = ToplamBass + SpData(A)
      Next A
      Ortalama = (ToplamBass) / 3 / 20
      '// Flashing Background

      If Flash Then Call glClearColor(Ortalama, Ortalama, 0, 0.5) Else Call glClearColor(0, 0, 0, 0.5)

      Call glDrawVu                                         '// Draw the scene

      '// Flashing Background
      '// If flashing then backgound else song name will flashing

      If Flash Then Call glColor3f(1, 1, 1) Else Call glColor3f(Ortalama, Ortalama, 0)

      '// Curent check use Helpscreen

      If HelpScreen Then

            Call DisplayHelpScreen
      Else
            '// Display Song Name

            If ShowSong = True Then

                  Call glEnable(GL_TEXTURE_2D)
                  Call glEnable(GL_BLEND)
                  Call glPrint(0, 135, Title & " ")
                  Call glDisable(GL_BLEND)
            End If

            If ShowVolMsg = True Then

                  Call glEnable(GL_TEXTURE_2D)
                  Call glEnable(GL_BLEND)
                  Call glPrint(0, 125, VolMsg & " ")
                  Call glDisable(GL_BLEND)
            End If

            If Ortalama > 0.44 Then

                  Bassvurdu = True
            End If

            If (Bassvurdu) And (Not ilk_bass) Then

                  Original_X_Position = 1 - ((Len(Title) \ 2) \ 15)
                  Original_Y_Position = -2.3
                  Current_X = Original_X_Position
                  ilk_bass = True
            End If

            If (1 - ((Len(Title) \ 2) / 15)) > Original_X_Position Then

                  Bassvurdu = False
                  ilk_bass = False
            End If
      End If
      RenderVu = True
End Function

'//------------------------------------------------------------------}
'//  Function to draw the actual scene                               }
'//------------------------------------------------------------------}
Public Function glDrawVu()

      Dim i As Single
      Dim j As Integer
      Dim BackgroundBeat As GLfloat
      Dim X
      Dim Y
      Dim z As GLfloat
      Dim A As Integer
      
      
      On Error Resume Next
      '// BackGround Beat Color - Average the first 10 values of SpectrumData
      BackgroundBeat = 0

      For i = 0 To 9

            BackgroundBeat = BackgroundBeat + buffer3(i) + buffer4(i)
            BackgroundBeat = (BackgroundBeat / 10) / 255
      Next i

      If EnableBeat Then

            Call glClearColor(0, 0, BackgroundBeat / 2, 0)
      Else
            Call glClearColor(0, 0, 0, 0)
      End If
      '// Clear screen and setup coordinates
      Call glClear(GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)    '// Clear The Screen And The Depth Buffer
      Call glLoadIdentity                                         '// Reset The View
      Call glTranslatef(0#, -5#, -50)
      Call glRotatef(30, 1, 0, 0)
      Call glRotatef(ElapsedTime / 100, 0, 1, 0)
      '// Translate spectrumData array values to OpenGL metrics
      '// first shift all the bars back one row.

      For j = 16 To 1 Step -1

            For i = 0 To 15

                  VUBars(i, j + 1) = VUBars(i, j)
            Next
      Next
      '// zero first row

      For A = 0 To 15

            VUBars(A, 1) = 0
      Next A
      'On Error Resume Next
      '// average all left and right 288 VU bars into 18 VU bars.

      For i = 0 To 255
            If buffer3(i) < 0 Then buffer3(i) = 0
            If buffer4(i) < 0 Then buffer4(i) = 0
            VUBars(i / 16, 1) = VUBars(i / 16, 1) + buffer3(i) + buffer4(i)
      Next i
      '// trim the extra high peaks

      For i = 0 To 15

            VUBars(i, 1) = VUBars(i, 1) / 102 / 2 '51

            If VUBars(i, 1) > 15 Then

                  VUBars(i, 1) = 15
            End If
      Next i
      '// display the VU bars

      If BounceBeat Then

            Y = BackgroundBeat
      Else
            Y = 0
      End If
      Call glBegin(GL_QUADS)

      For j = 1 To 17

            z = 13 - j * 1.5

            For i = 0 To 15

                  X = -13.25 + i * 1.5
                  Call VUBox(X, Y, z, VUBars(i, j))
            Next
      Next
      Call glEnd
End Function

'//** HELP SCREEN
Sub DisplayHelpScreen()

      Call glEnable(GL_BLEND)
      Call glColor3f(1, 1, 1)                                       ' // White Font Color
      Call glPrint(4, 75, ("HILFE - TASTATUR - BEFEHLE "))
      Call glPrint(4, 85, ("------------------------- "))
      Call glPrint(4, 95, ("RAUF      : LAUTSTAERKE + "))
      Call glPrint(4, 105, ("RUNTER  : LAUTSTAERKE - "))
      Call glPrint(4, 115, ("LINKS     : VORHERIGES LIED "))
      Call glPrint(4, 125, ("RECHTS  : NAECHSTES LIED "))
      Call glPrint(4, 135, ("F5           : HINTERGRUND AUFLEUCHTEN "))
      Call glDisable(GL_BLEND)

End Sub

Public Function drawBackgroundEffect()

Dim s As Single
Dim i As Integer
Dim R, G, b As Single
    Call glDisable(GL_TEXTURE_2D)
    Call glBegin(GL_TRIANGLE_STRIP)
    On Error Resume Next
        For i = 0 To 255
            If Playing = True Then
            s = 0.5 + Sin(buffer3(i) / 465) * 0.2 + Cos(buffer4(i) + buffer3(i) / 657) * 0.1
            R = 0.5 + Sin(buffer3(i) + buffer4(i) / 50 + i / 1.6) * 0.5
            G = 0.5 + Sin(buffer3(i) + buffer4(i) / 200 + 720 + i / 1.6) * 0.5
            b = 0.5 + Sin(buffer3(i) + buffer4(i) / 150 + 720 + i / 1.6) * 0.5
            Else
            s = 0.5 + Sin(s / 465) * 0.2 + Cos(s / 657) * 0.1
            End If
            R = 0.5 + Sin(ElapsedTime / 100 + i / 1.6) * 0.5
            G = 0.5 + Sin(ElapsedTime / 200 + 720 + i / 1.6) * 0.5
            b = 0.5 + Sin(ElapsedTime / 100 + 720 + i / 1.6) * 0.5
            Call glColor3f(R, G, b)
            Call glVertex3f(Sin(P180 * i * 5) * s, Cos(P180 * i * 5) * s, Sin(P180 * (i * 10 + ElapsedTime / 500)) * (0.5 + Sin(ElapsedTime / 300) * 0.3))
            Call glColor3f(b, G, R)
            Call glVertex3f(Sin(P180 * i * 5) * s * 2, Cos(P180 * i * 5) * s * 2, 1 + Sin(P180 * (i * (20) + ElapsedTime / 500)) * (0.5 + Sin(ElapsedTime / 800) * 0.4 + Cos(ElapsedTime / 450) * 0.4))
        Next
  Call glEnd
End Function

